module AB3_4 where

import Prelude (putStrLn,return)
import Types (CSMInstance, createCSM, coa, cob, lena, lenb, ssc)
import SPLib.Basic 
  (Show(show), Int, Bool(True,False), String, Maybe (Just,Nothing), trace, undefined, if', not, (<), (+), (-), (==), (<=), (<), (&&), (||), ($))
import SPLib.List (prepend, map)

import Shrimp.Interpreter
import Control.Monad (when)
import System.Directory (doesDirectoryExist, removeDirectoryRecursive)
import System.Process (system)

sp__thisFileName = "AB3_4.hs"

csm :: [String] -> [String] -> Bool
csm a b = csm' (createCSM a b)

main = do
  putStrLn "Removing directory AB3_4/csmAlg if it exists"

  dirExists <- doesDirectoryExist "AB3_4/csmAlg"
  when dirExists $ removeDirectoryRecursive "AB3_4/csmAlg"

  putStrLn "Computing traces"
  putStrLn $ show $ csm ["abab","ab","ab","ab"] ["ab","aba","bab","ab"]
  putStrLn $ show $ csm ["abab","ab","ab","ab"] ["ab","aba","bb","ab"]
  putStrLn $ show $ csm [] [""]
  putStrLn $ show $ csm ["",""] []
  putStrLn $ show $ csm ["a"] ["b"]

  putStrLn "Comparing traces with references"
  system "spc --mode=compareDirs AB3_4/reference AB3_4/csmAlg --omitEqual"
  putStrLn "\nIf no differences are shown above, this means the traces produced by your program equal their reference counterparts"
  
-- *** DO NOT MODIFY ABOVE CODE ***

--START OF PROGRAM csmAlg
csm' = undefined
--END OF PROGRAM csmAlg
